<?php

namespace SGalinski\SgMail\UserFunc;

/***************************************************************
 *  Copyright notice
 *
 *  (c) sgalinski Internet Services (https://www.sgalinski.de)
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

use SGalinski\SgMail\Service\RegisterService;
use TYPO3\CMS\Core\Utility\ExtensionManagementUtility;
use TYPO3\CMS\Core\Utility\GeneralUtility;

/**
 * Class ExtensionConfiguration
 *
 * @package SGalinski\SgMail\UserFunc
 */
class ExtensionConfiguration {

	/**
	 * Displays all registered sg mail templates for easy use with the blacklist feature
	 *
	 * @return string
	 */
	public function displayTemplates(): string {
		$result = '';

		try {
			// These are internal methods that can vanish at any moment
			// TODO: We need to change this whole TypoScript fetching at these early stages
			ExtensionManagementUtility::loadExtLocalconf();
			ExtensionManagementUtility::loadBaseTca();
			$registerService = GeneralUtility::makeInstance(RegisterService::class);
			$registerArray = $registerService->getRegisterArray();
			foreach ($registerArray as $extensionKey => $extension) {
				/** @var array $extension */
				foreach ($extension as $templateKey => $template) {
					$result .= $extensionKey . '.' . $templateKey . '<br>';
				}
			}

		} catch (\Exception $exception) {
			return 'The template list could not be loaded!';
		}

		return $result;
	}
}
